#[doc = "Register `CNTL` reader"]
pub struct R(crate::R<CNTL_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<CNTL_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::convert::From<crate::R<CNTL_SPEC>> for R {
    fn from(reader: crate::R<CNTL_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `CNTL` writer"]
pub struct W(crate::W<CNTL_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<CNTL_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl core::convert::From<crate::W<CNTL_SPEC>> for W {
    fn from(writer: crate::W<CNTL_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `TT_ENABLE` reader - TTCAN enable/disable?0=TTCAN is disabled; Interrupt_can is sourced from 3PIP.? INT_EBL.GLOBAL_INT_ENBL & (INT_EBL\\[i\\]
& INT_STATUS\\[i\\])?1=TTCAN is enabled; Interrupt_can is sourced from INTR_CAN_MASKED."]
pub struct TT_ENABLE_R(crate::FieldReader<bool, bool>);
impl TT_ENABLE_R {
    pub(crate) fn new(bits: bool) -> Self {
        TT_ENABLE_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for TT_ENABLE_R {
    type Target = crate::FieldReader<bool, bool>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `TT_ENABLE` writer - TTCAN enable/disable?0=TTCAN is disabled; Interrupt_can is sourced from 3PIP.? INT_EBL.GLOBAL_INT_ENBL & (INT_EBL\\[i\\]
& INT_STATUS\\[i\\])?1=TTCAN is enabled; Interrupt_can is sourced from INTR_CAN_MASKED."]
pub struct TT_ENABLE_W<'a> {
    w: &'a mut W,
}
impl<'a> TT_ENABLE_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x01) | (value as u32 & 0x01);
        self.w
    }
}
#[doc = "Field `IP_ENABLE` reader - IP Enable/Disable?0=IP is disabled/reset?1=IP is enabled/running"]
pub struct IP_ENABLE_R(crate::FieldReader<bool, bool>);
impl IP_ENABLE_R {
    pub(crate) fn new(bits: bool) -> Self {
        IP_ENABLE_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for IP_ENABLE_R {
    type Target = crate::FieldReader<bool, bool>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `IP_ENABLE` writer - IP Enable/Disable?0=IP is disabled/reset?1=IP is enabled/running"]
pub struct IP_ENABLE_W<'a> {
    w: &'a mut W,
}
impl<'a> IP_ENABLE_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 31)) | ((value as u32 & 0x01) << 31);
        self.w
    }
}
impl R {
    #[doc = "Bit 0 - TTCAN enable/disable?0=TTCAN is disabled; Interrupt_can is sourced from 3PIP.? INT_EBL.GLOBAL_INT_ENBL & (INT_EBL\\[i\\]
& INT_STATUS\\[i\\])?1=TTCAN is enabled; Interrupt_can is sourced from INTR_CAN_MASKED."]
    #[inline(always)]
    pub fn tt_enable(&self) -> TT_ENABLE_R {
        TT_ENABLE_R::new((self.bits & 0x01) != 0)
    }
    #[doc = "Bit 31 - IP Enable/Disable?0=IP is disabled/reset?1=IP is enabled/running"]
    #[inline(always)]
    pub fn ip_enable(&self) -> IP_ENABLE_R {
        IP_ENABLE_R::new(((self.bits >> 31) & 0x01) != 0)
    }
}
impl W {
    #[doc = "Bit 0 - TTCAN enable/disable?0=TTCAN is disabled; Interrupt_can is sourced from 3PIP.? INT_EBL.GLOBAL_INT_ENBL & (INT_EBL\\[i\\]
& INT_STATUS\\[i\\])?1=TTCAN is enabled; Interrupt_can is sourced from INTR_CAN_MASKED."]
    #[inline(always)]
    pub fn tt_enable(&mut self) -> TT_ENABLE_W {
        TT_ENABLE_W { w: self }
    }
    #[doc = "Bit 31 - IP Enable/Disable?0=IP is disabled/reset?1=IP is enabled/running"]
    #[inline(always)]
    pub fn ip_enable(&mut self) -> IP_ENABLE_W {
        IP_ENABLE_W { w: self }
    }
    #[doc = "Writes raw bits to the register."]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "Control\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [cntl](index.html) module"]
pub struct CNTL_SPEC;
impl crate::RegisterSpec for CNTL_SPEC {
    type Ux = u32;
}
#[doc = "`read()` method returns [cntl::R](R) reader structure"]
impl crate::Readable for CNTL_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [cntl::W](W) writer structure"]
impl crate::Writable for CNTL_SPEC {
    type Writer = W;
}
#[doc = "`reset()` method sets CNTL to value 0"]
impl crate::Resettable for CNTL_SPEC {
    #[inline(always)]
    fn reset_value() -> Self::Ux {
        0
    }
}
